var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { commonsAiDataHumanise } from '../helpers/commons-ai-data';
import { CommonsAiNeuralNetwork } from './commons-ai-neural-network';
export class CommonsAiArrayOutputNeuralNetwork extends CommonsAiNeuralNetwork {
    constructor(length, humaniseOutput) {
        super();
        this.length = length;
        this.humaniseOutput = humaniseOutput;
    }
    processIn(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const processed = [];
            for (const d of data) {
                const numbers = yield this.convertInputData(d.input);
                if (this.validate)
                    CommonsAiNeuralNetwork.validateData0To1(numbers);
                if (d.output.length !== this.length)
                    throw new Error('Output is not a consistent length');
                const clone = [...d.output];
                if (this.humaniseOutput) {
                    for (let i = this.length; i-- > 0;)
                        clone[i] = commonsAiDataHumanise(clone[i], this.humaniseOutput);
                }
                processed.push({
                    input: numbers,
                    output: clone
                });
            }
            return processed;
        });
    }
    processOut(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const array = [...new Array(this.length).fill(0)];
            for (let i = this.length; i-- > 0;)
                array[i] = data[i.toString(10)];
            return array;
        });
    }
}
//# sourceMappingURL=commons-ai-array-output-neural-network.js.map