import { TCommonsAiTestResults } from '../types/tcommons-ai-test-results';
import { TCommonsAiOutputWithConfidence } from '../types/tcommons-ai-output-with-confidence';
import { CommonsAiIntegerOutputNeuralNetwork } from './commons-ai-integer-output-neural-network';
export declare abstract class CommonsAiBooleanOutputNeuralNetwork<I> extends CommonsAiIntegerOutputNeuralNetwork<I> {
    constructor(humaniseOutput?: number);
    trainForBooleans(examples: Map<boolean, I[]>, hiddenLayers: number[], iterations?: number, errorThresh?: number): Promise<void>;
    runForBoolean(query: I): Promise<TCommonsAiOutputWithConfidence<boolean>>;
    testForBooleans(examples: Map<boolean, I[]>): Promise<TCommonsAiTestResults<I, boolean>>;
    protected isCorrectOutput(o: number, additionalData?: {}): boolean;
    protected fittestEvolution(ai: I, ao: TCommonsAiOutputWithConfidence<number>, bi: I, bo: TCommonsAiOutputWithConfidence<number>, additionalData?: {}): I;
    dreamForBoolean(goal: boolean, maxIterations: number, errorThreshold?: number, additionalData?: {}): Promise<I>;
}
