import { TCommonsAiTestResults } from '../types/tcommons-ai-test-results';
import { TCommonsAiOutputWithConfidence } from '../types/tcommons-ai-output-with-confidence';
import { CommonsAiIntegerOutputNeuralNetwork } from './commons-ai-integer-output-neural-network';
export declare abstract class CommonsAiEnumOutputNeuralNetwork<I, E extends string> extends CommonsAiIntegerOutputNeuralNetwork<I> {
    private enums;
    constructor(enums: E[], humaniseOutput?: number);
    trainForEnums(examples: Map<E, I[]>, hiddenLayers: number[], iterations?: number, errorThresh?: number): Promise<void>;
    runForEnum(query: I): Promise<TCommonsAiOutputWithConfidence<E>>;
    testForEnums(examples: Map<E, I[]>): Promise<TCommonsAiTestResults<I, E>>;
}
