import { TCommonsAiTrainingData } from '../types/tcommons-ai-training-data';
import { TCommonsAiIntegerOutputTrainingData } from '../types/tcommons-ai-integer-output-training-data';
import { TCommonsAiTestResults } from '../types/tcommons-ai-test-results';
import { TCommonsAiOutputWithConfidence } from '../types/tcommons-ai-output-with-confidence';
import { CommonsAiConfidenceNeuralNetwork } from './commons-ai-confidence-neural-network';
export declare abstract class CommonsAiIntegerOutputNeuralNetwork<I> extends CommonsAiConfidenceNeuralNetwork<I, number> {
    private max;
    private min;
    private humaniseOutput?;
    private delta;
    constructor(max: number, min?: number, humaniseOutput?: number | undefined);
    protected processIn(data: TCommonsAiIntegerOutputTrainingData<I>[]): Promise<TCommonsAiTrainingData[]>;
    protected processOutWithConfidence(data: {}): Promise<TCommonsAiOutputWithConfidence<number>>;
    trainForIntegers(examples: Map<number, I[]>, hiddenLayers: number[], iterations?: number, errorThresh?: number, crossValidate?: boolean): Promise<void>;
    runForInteger(query: I): Promise<TCommonsAiOutputWithConfidence<number>>;
    testForIntegers(examples: Map<number, I[]>): Promise<TCommonsAiTestResults<I, number>>;
}
