import { TCommonsAiTrainingData } from '../types/tcommons-ai-training-data';
import { TCommonsAiObjectOutputTrainingData } from '../types/tcommons-ai-object-output-training-data';
import { TCommonsAiObjectTestResults } from '../types/tcommons-ai-object-test-results';
import { TCommonsAiObject } from '../types/tcommons-ai-object';
import { CommonsAiNeuralNetwork } from './commons-ai-neural-network';
export declare abstract class CommonsAiObjectOutputNeuralNetwork<I, E extends string> extends CommonsAiNeuralNetwork<I, TCommonsAiObject<E>> {
    private enumsValues;
    private humaniseOutput?;
    constructor(enumsValues: E[], humaniseOutput?: number | undefined);
    protected processIn(data: TCommonsAiObjectOutputTrainingData<I, E>[]): Promise<TCommonsAiTrainingData[]>;
    protected processOut(data: {}): Promise<TCommonsAiObject<E>>;
    trainForSingularEnumObjects(examples: Map<E, I[]>, hiddenLayers: number[], iterations?: number, errorThresh?: number, crossValidate?: boolean): Promise<void>;
    testForSingularEnumObjects(examples: Map<E, I[]>): Promise<TCommonsAiObjectTestResults<I, E>>;
}
