export function commonsAiDataHumanise(value, magnitude = 0.1) {
    const error = Math.random() - 0.5;
    value += error * magnitude;
    if (value < 0)
        value = 0;
    if (value > 1)
        value = 1;
    return value;
}
export function commonsAiDataHumaniseArray(values, magnitude = 0.1) {
    for (let i = values.length; i-- > 0;) {
        values[i] = commonsAiDataHumanise(values[i], magnitude);
    }
}
export function commonsAiDataTrainingSet(datas, output, noise = 0.1) {
    return datas
        .map((data) => ({
        input: data,
        output: output
            .map((v) => commonsAiDataHumanise(v, noise))
    }));
}
export function commonsAiDataTrainingSetForNumber(datas, output, noise = 0.1) {
    return commonsAiDataTrainingSet(datas, [output], noise);
}
export function commonsAiDataTrainingSetForBoolean(datas, output, noise = 0.1) {
    return commonsAiDataTrainingSetForNumber(datas, output ? 1 : 0, noise);
}
//# sourceMappingURL=commons-ai-data.js.map