import { commonsMapRank, EMapRankDirection } from 'tscommons-es-core';
export function commonsAiObjectTop(object, top) {
    if (top < 1)
        throw new Error('Top is out of range');
    const map = new Map();
    for (const e of Object.keys(object))
        map.set(e, object[e]);
    const scored = commonsMapRank(map, EMapRankDirection.DESC, top);
    const tops = {};
    for (const s of scored)
        tops[s.item] = s.rank;
    return tops;
}
export function commonsAiObjectBest(object, threshold) {
    const top = commonsAiObjectTop(object, 1);
    if (Object.keys(top).length === 0)
        return undefined;
    const match = Object.keys(top)[0];
    if (!threshold || top[match] > threshold)
        return Object.keys(top)[0];
    return undefined;
}
//# sourceMappingURL=commons-ai-object.js.map